Bug 1374948 - Review Request: dynamips - Cisco router emulator
Summary: Review Request: dynamips - Cisco router emulator
Status: CLOSED CANTFIX
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Michal Ruprich 🐧
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2016-09-10 20:22 UTC by Athmane Madjoudj
Modified: 2018-12-05 12:37 UTC (History)
5 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2018-12-03 13:45:06 UTC
mruprich: fedora-review?
mruprich: needinfo-


Attachments (Terms of Use)

Description Athmane Madjoudj 2016-09-10 20:22:40 UTC
Spec URL: https://athmane.fedorapeople.org/pkgs/gns3/dynamips.spec
SRPM URL: https://athmane.fedorapeople.org/pkgs/gns3/dynamips-0.2.16-1.fc24.src.rpm
Description:
Dynamips emulates Cisco 7200/3600/3725/3745/2691 routers on a traditional PC.

Fedora Account System Username: athmane

Comment 1 Athmane Madjoudj 2016-09-10 20:26:39 UTC
We had before some attempt to package this, I'm giving it a try since the policy regarding emulator has been relaxed.
 
Below Copr build [1], please note that there's a binary blob (mips microcode), I've asked upstream to provide more details (license and step to build from source) [2]

[1] https://copr.fedorainfracloud.org/coprs/athmane/gns3-extra/build/451517/

[2] https://github.com/GNS3/dynamips/issues/75

Comment 2 Michal Ruprich 🐧 2016-09-20 06:56:16 UTC
Hi, I'm not aware of any policy regarding emulators. Could you be more specific? Perhaps provide some link to anything explaining this?

Also there seems to be a problem with the Copr link. I am unable to open it. Could you re-check whether it is correct?

Comment 3 Michal Ruprich 🐧 2016-09-20 07:49:39 UTC
Please disregard my inquiry about the copr repo. I totally forgot about the outage today.

Comment 4 Michal Ruprich 🐧 2016-09-21 11:30:44 UTC
Ok I found a note about emulators and the only way to include this would be to provide licenses to the mips microcode as you mentioned at the beginning. I did the review at least on everything that was possible but you should pay attention to the "Package functions as described" part. I commented on that so if I am wrong about this don't hesitate to correct me.

If you could provide a link to the review request you posted last time (the one that got rejected) it might give me some more insight on the emulator issue. 

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- All build dependencies are listed in BuildRequires, except for any that
  are listed in the exceptions section of Packaging Guidelines.
  Note: These BR are not needed: make gcc
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#Exceptions_2

	##Consider removing these dependencies, both are required by default thus no reason to explicitly require them here

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[-]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[!]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.

	##Described below

[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 309 files have unknown license.
     Detailed output of licensecheck in
     /home/mruprich/devel/rev/dynamips/1374948-dynamips/licensecheck.txt

	##1. All the files need to be licensed under the same license that is specified in the spec file
	     Either add the license(s) into each file or create a separate file and add %license pointing to this file in the spec file
	##2. I am not able to include this in Fedora until the binary blob is permitted by owner and licensed under Fedora permissible license

[-]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[-]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 143360 bytes in 6 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.

	##Mentioned above

[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     dynamips-debuginfo
[!]: Package functions as described.

	##From my point of view I am unable to test this - I would need a working cisco router iso image and those are proprietary and not available

[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.

	##Add the check section if possible

[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: dynamips-0.2.16-1.fc24.x86_64.rpm
          dynamips-debuginfo-0.2.16-1.fc24.x86_64.rpm
          dynamips-0.2.16-1.fc24.src.rpm
3 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (debuginfo)
-------------------
Checking: dynamips-debuginfo-0.2.16-1.fc24.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
2 packages and 0 specfiles checked; 0 errors, 0 warnings.



Requires
--------
dynamips (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libdl.so.2()(64bit)
    libelf.so.1()(64bit)
    libelf.so.1(ELFUTILS_1.0)(64bit)
    libnsl.so.1()(64bit)
    libpcap.so.1()(64bit)
    libpthread.so.0()(64bit)
    librt.so.1()(64bit)
    rtld(GNU_HASH)

dynamips-debuginfo (rpmlib, GLIBC filtered):



Provides
--------
dynamips:
    dynamips
    dynamips(x86-64)

dynamips-debuginfo:
    dynamips-debuginfo
    dynamips-debuginfo(x86-64)



Source checksums
----------------
https://github.com/GNS3/dynamips/archive/v0.2.16/dynamips-0.2.16.tar.gz :
  CHECKSUM(SHA256) this package     : 0fcf18d701898a77cb589bd9bad16dde436ac1ccb87516fefe07d09de1a196c0
  CHECKSUM(SHA256) upstream package : 0fcf18d701898a77cb589bd9bad16dde436ac1ccb87516fefe07d09de1a196c0


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1374948
Buildroot used: fedora-24-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 5 Athmane Madjoudj 2016-09-21 18:59:44 UTC
Thank you for reviewing.

The attempts for packaging dynamips was from the community, not me, I created this spec from scratch, I'll provide the links for this if needed. 

Regarding the exception for the Build Requirements, I think it was removed since the buildroot will be minimized (like removing perl, compiler, make etc...), fedora-review tool still uses the old guidelines.

Comment 6 Michal Ruprich 🐧 2016-09-27 11:34:09 UTC
Hi Athmane,

there are some more issues mentioned in the review. I will repeat them here:

[!]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.

	##Described below

[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 309 files have unknown license.
     
	##1. All the files need to be licensed under the same license that is 
             specified in the spec file (or a combination of licenses)
        ##2. I am not able to include this in Fedora until the binary blob is 
             permitted by owner and licensed under Fedora permissible license
             (but you mentioned that in the beginning)
        ##3. the comment about 309 files without license i because there are
             no license(s) texts in each file

[!]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.

	##Mentioned above

[!]: Package functions as described.

	##From my point of view I am unable to test this - I would need a 
          working cisco router iso image and those are proprietary and not 
          available, but I may be wrong 

[!]: %check is present and all tests pass.

	##Add the check section if possible

Please have a look at these. Thanks

Michal

Comment 7 Nicolas Chauvet (kwizart) 2018-12-03 13:45:06 UTC
FYI, dynamips is provided by the rpmfusion nonfree section.
This is because lot of binary blob there.

Because of this, I'm closing this as this is unlikely to be distributable in fedora as such.

Comment 8 Athmane Madjoudj 2018-12-05 09:13:20 UTC
Thank you for the heads up.

These days, GNS3 is quite usable without dynamips since most of network vendors are providing x86 version of their OS as KVM/QEMU image.

eg: https://docs.gns3.com/appliances/cisco-iosv.html   (A valid Cisco account is needed)

Comment 9 Nicolas Chauvet (kwizart) 2018-12-05 12:37:36 UTC
Indeed, as I understand dynamips is only relevant on few older cisco devices (using mips/ppc).
(testing gns3 on nexus 9000 using kvm these days).


Note You need to log in before you can comment on or make changes to this bug.